GDAL

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | List of all members
OGRLinearRing Class Referenceabstract

Concrete representation of a closed ring. More...

`#include <ogr_geometry.h>`

Inheritance diagram for OGRLinearRing:

## Public Types
typedef OGRPoint | ChildType
| Type of child elements.

## Public Member Functions
| OGRLinearRing ()=default
| Constructor.
| OGRLinearRing (const OGRLinearRing &other)
| Copy constructor. More...
| OGRLinearRing (const OGRLinearRing *)
| Constructor. More...
OGRLinearRing & | operator= (const OGRLinearRing &other)
| Assignment operator. More...
virtual const char * | getGeometryName () const override
| Fetch WKT name for geometry type. More...
virtual OGRLinearRing * | clone () const override
| Make a copy of this object. More...
virtual void | closeRings () override
| Force rings to be closed. More...
OGRBoolean | isPointInRing (const OGRPoint *pt, int bTestEnvelope=TRUE) const
| Returns whether the point is inside the ring. More...
OGRBoolean | isPointOnRingBoundary (const OGRPoint *pt, int bTestEnvelope=TRUE) const
| Returns whether the point is on the ring boundary. More...
virtual OGRErr | transform (OGRCoordinateTransformation *poCT) override
| Apply arbitrary coordinate transformation to geometry. More...
OGRLineString * | toUpperClass ()
| Return pointer of this in upper class.
const OGRLineString * | toUpperClass () const
| Return pointer of this in upper class.
virtual void | accept (IOGRGeometryVisitor *visitor) override
| Accept a visitor. More...
virtual void | accept (IOGRConstGeometryVisitor *visitor) const override
| Accept a visitor. More...
virtual OGRLineString * | CurveToLine (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const override
| Return a linestring from a curve geometry. More...
virtual OGRGeometry * | getCurveGeometry (const char *const *papszOptions=nullptr) const override
| Return curve version of this geometry. More...
virtual double | get_Area () const override
| Get the area of the (closed) curve. More...
virtual double | get_GeodesicArea (const OGRSpatialReference *poSRSOverride=nullptr) const override
| Get the area of the (closed) curve, considered as a surface on the underlying ellipsoid of the SRS attached to the geometry. More...
virtual double | get_GeodesicLength (const OGRSpatialReference *poSRSOverride=nullptr) const override
| Get the length of the curve, considered as a geodesic line on the underlying ellipsoid of the SRS attached to the geometry. More...
virtual OGRwkbGeometryType | getGeometryType () const override
| Fetch geometry type. More...
virtual int | isClockwise () const override
| Returns TRUE if the ring has clockwise winding (or less than 2 points) More...
Iterator | begin ()
| Return begin of point iterator. More...
ConstIterator | begin () const
| Return begin of point iterator. More...
Iterator | end ()
| Return end of point iterator.
ConstIterator | end () const
| Return end of point iterator.
OGRErr | importFromWkb (const GByte *, size_t=static_cast< size_t >(-1), OGRwkbVariant=wkbVariantOldOgc)
| Assign geometry from well known binary data. More...
OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known binary format. More...
OGRErr | importFromWkt (const char **) override
| deprecated More...
virtual OGRErr | importFromWkt (const char **ppszInput)=0
| Assign geometry from well known text data. More...
OGRErr | importFromWkt (char **ppszInput)
| Deprecated. More...
virtual std::string | exportToWkt (const OGRWktOptions &opts=OGRWktOptions(), OGRErr *err=nullptr) const override
| Export a simple curve to WKT. More...
OGRErr | exportToWkt (char **ppszDstText, OGRwkbVariant=wkbVariantOldOgc) const
| Convert a geometry into well known text format. More...
virtual std::string | exportToWkt (const OGRWktOptions &opts=OGRWktOptions(), OGRErr *err=nullptr) const=0
| Export a WKT geometry. More...
virtual void | empty () override
| Clear geometry information. More...
virtual void | getEnvelope (OGREnvelope *psEnvelope) const override
| Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. More...
virtual void | getEnvelope (OGREnvelope3D *psEnvelope) const override
| Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure. More...
virtual OGRBoolean | IsEmpty () const override
| Returns TRUE (non-zero) if the object has no points. More...
virtual double | get_Length () const override
| Returns the length of the curve. More...
virtual void | StartPoint (OGRPoint *) const override
| Return the curve start point. More...
virtual void | EndPoint (OGRPoint *) const override
| Return the curve end point. More...
virtual void | Value (double, OGRPoint *) const override
| Fetch point at given distance along curve. More...
virtual double | Project (const OGRPoint *) const
| Project point on linestring. More...
virtual OGRLineString * | getSubLine (double, double, int) const
| Get the portion of linestring. More...
virtual int | getNumPoints () const override
| Fetch vertex count. More...
void | getPoint (int, OGRPoint *) const
| Fetch a point in line string. More...
double | getX (int i) const
| Get X at vertex. More...
double | getY (int i) const
| Get Y at vertex. More...
double | getZ (int i) const
| Get Z at vertex. More...
double | getM (int i) const
| Get measure at vertex. More...
virtual OGRBoolean | Equals (const OGRGeometry *) const override
| Returns TRUE if two geometries are equivalent. More...
virtual bool | setCoordinateDimension (int nDimension) override
| Set the coordinate dimension. More...
virtual bool | set3D (OGRBoolean bIs3D) override
| Add or remove the Z coordinate dimension. More...
virtual bool | setMeasured (OGRBoolean bIsMeasured) override
| Add or remove the M coordinate dimension. More...
bool | setNumPoints (int nNewPointCount, int bZeroizeNewContent=TRUE)
| Set number of points in geometry. More...
bool | setPoint (int, OGRPoint *)
| Set the location of a vertex in line string. More...
bool | setPoint (int, double, double)
| Set the location of a vertex in line string. More...
bool | setPoint (int, double, double, double)
| Set the location of a vertex in line string. More...
bool | setPoint (int, double, double, double, double)
| Set the location of a vertex in line string. More...
bool | setZ (int, double)
| Set the Z of a vertex in line string. More...
bool | setM (int, double)
| Set the M of a vertex in line string. More...
bool | setPointM (int, double, double, double)
| Set the location of a vertex in line string. More...
bool | setPoints (int, const OGRRawPoint *, const double *=nullptr)
| Assign all points in a line string. More...
bool | setPoints (int, const OGRRawPoint *, const double *, const double *)
| Assign all points in a line string. More...
bool | setPoints (int, const double *padfX, const double *padfY, const double *padfZIn=nullptr)
| Assign all points in a line string. More...
bool | setPoints (int, const double *padfX, const double *padfY, const double *padfZIn, const double *padfMIn)
| Assign all points in a line string. More...
bool | setPointsM (int, const OGRRawPoint *, const double *)
| Assign all points in a line string. More...
bool | setPointsM (int, const double *padfX, const double *padfY, const double *padfMIn=nullptr)
| Assign all points in a line string. More...
bool | addPoint (const OGRPoint *)
| Add a point to a line string. More...
bool | addPoint (double, double)
| Add a point to a line string. More...
bool | addPoint (double, double, double)
| Add a point to a line string. More...
bool | addPoint (double, double, double, double)
| Add a point to a line string. More...
bool | addPointM (double, double, double)
| Add a point to a line string. More...
bool | removePoint (int)
| Remove a point from a line string. More...
void | getPoints (OGRRawPoint *, double *=nullptr) const
| Returns all points of line string. More...
void | getPoints (void *pabyX, int nXStride, void *pabyY, int nYStride, void *pabyZ=nullptr, int nZStride=0, void *pabyM=nullptr, int nMStride=0) const
| Returns all points of line string. More...
void | addSubLineString (const OGRLineString *, int nStartVertex=0, int nEndVertex=-1)
| Add a segment of another linestring to this one. More...
void | reversePoints () override
| Reverse point order. More...
virtual OGRPointIterator * | getPointIterator () const override
| Returns a point iterator over the curve. More...
virtual void | flattenTo2D () override
| Convert geometry to strictly 2D. More...
virtual bool | segmentize (double dfMaxLength) override
| Modify the geometry such it has no segment longer then the given distance. More...
virtual void | swapXY () override
| Swap x and y coordinates. More...
virtual int | get_IsClosed () const
| Return TRUE if curve is closed. More...
virtual int | getDimension () const override
| Get the dimension of this object. More...
virtual OGRBoolean | IsConvex () const
| Returns if a (closed) curve forms a convex shape. More...
OGRSimpleCurve * | toSimpleCurve ()
| Down-cast to OGRSimpleCurve*. More...
const OGRSimpleCurve * | toSimpleCurve () const
| Down-cast to OGRSimpleCurve*. More...
bool | operator== (const OGRGeometry &other) const
| Returns if two geometries are equal.
bool | operator!= (const OGRGeometry &other) const
| Returns if two geometries are different.
virtual int | getCoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
int | CoordinateDimension () const
| Get the dimension of the coordinates in this object. More...
virtual OGRBoolean | IsValid () const
| Test if the geometry is valid. More...
virtual OGRGeometry * | MakeValid (CSLConstList papszOptions=nullptr) const
| Attempts to make an invalid geometry valid without losing vertices. More...
virtual OGRGeometry * | Normalize () const
| Attempts to bring geometry into normalized/canonical form. More...
virtual OGRBoolean | IsSimple () const
| Test if the geometry is simple. More...
OGRBoolean | Is3D () const
OGRBoolean | IsMeasured () const
virtual OGRBoolean | IsRing () const
| Test if the geometry is a ring. More...
OGRwkbGeometryType | getIsoGeometryType () const
| Get the geometry type that conforms with ISO SQL/MM Part3. More...
void | dumpReadable (FILE *, const char *=nullptr, CSLConstList papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file. More...
std::string | dumpReadable (const char *=nullptr, CSLConstList papszOptions=nullptr) const
| Dump geometry in well known text format to indicated output file. More...
virtual char * | exportToGML (const char *const *papszOptions=nullptr) const
| Convert a geometry into GML format. More...
virtual char * | exportToKML () const
| Convert a geometry into KML format. More...
virtual char * | exportToJson (CSLConstList papszOptions=nullptr) const
| Convert a geometry into GeoJSON format. More...
GEOSGeom | exportToGEOS (GEOSContextHandle_t hGEOSCtxt, bool bRemoveEmptyParts=false) const
| Returns a GEOSGeom object corresponding to the geometry. More...
virtual OGRBoolean | hasCurveGeometry (int bLookForNonLinear=FALSE) const
| Returns if this geometry is or has curve geometry. More...
virtual OGRGeometry * | getLinearGeometry (double dfMaxAngleStepSizeDegrees=0, const char *const *papszOptions=nullptr) const
| Return, possibly approximate, non-curve version of this geometry. More...
void | roundCoordinates (const OGRGeomCoordinatePrecision &sPrecision)
| Round coordinates of the geometry to the specified precision. More...
void | roundCoordinatesIEEE754 (const OGRGeomCoordinateBinaryPrecision &options)
| Round coordinates of a geometry, exploiting characteristics of the IEEE-754 double-precision binary representation. More...
virtual void | assignSpatialReference (const OGRSpatialReference *poSR)
| Assign spatial reference to this object. More...
const OGRSpatialReference * | getSpatialReference (void) const
| Returns spatial reference system for object. More...
OGRErr | transformTo (const OGRSpatialReference *poSR)
| Transform geometry to new spatial reference system. More...
virtual OGRBoolean | Intersects (const OGRGeometry *) const
| Do these features intersect? More...
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
| Test for disjointness. More...
virtual OGRBoolean | Touches (const OGRGeometry *) const
| Test for touching. More...
virtual OGRBoolean | Crosses (const OGRGeometry *) const
| Test for crossing. More...
virtual OGRBoolean | Within (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Contains (const OGRGeometry *) const
| Test for containment. More...
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
| Test for overlap. More...
virtual OGRGeometry * | Boundary () const
| Compute boundary. More...
virtual double | Distance (const OGRGeometry *) const
| Compute distance between two geometries. More...
virtual OGRGeometry * | ConvexHull () const
| Compute convex hull. More...
virtual OGRGeometry * | ConcaveHull (double dfRatio, bool bAllowHoles) const
| Compute "concave hull" of a geometry. More...
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const
| Compute buffer of geometry. More...
virtual OGRGeometry * | BufferEx (double dfDistance, CSLConstList papszOptions) const
| Compute buffer of geometry. More...
virtual OGRGeometry * | Intersection (const OGRGeometry *) const
| Compute intersection. More...
virtual OGRGeometry * | Union (const OGRGeometry *) const
| Compute union. More...
virtual OGRGeometry * | UnionCascaded () const
| Compute union using cascading. More...
OGRGeometry * | UnaryUnion () const
| Returns the union of all components of a single geometry. More...
virtual OGRGeometry * | Difference (const OGRGeometry *) const
| Compute difference. More...
virtual OGRGeometry * | SymDifference (const OGRGeometry *) const
| Compute symmetric difference. More...
virtual OGRErr | Centroid (OGRPoint *poPoint) const
| Compute the geometry centroid. More...
virtual OGRGeometry * | Simplify (double dTolerance) const
| Simplify the geometry. More...
OGRGeometry * | SimplifyPreserveTopology (double dTolerance) const
| Simplify the geometry while preserving topology. More...
virtual OGRGeometry * | DelaunayTriangulation (double dfTolerance, int bOnlyEdges) const
| Return a Delaunay triangulation of the vertices of the geometry. More...
virtual OGRGeometry * | Polygonize () const
| Polygonizes a set of sparse edges. More...
virtual double | Distance3D (const OGRGeometry *poOtherGeom) const
| Returns the 3D distance between two geometries. More...
OGRGeometry * | SetPrecision (double dfGridSize, int nFlags) const
| Set the geometry's precision, rounding all its coordinates to the precision grid, and making sure the geometry is still valid. More...
virtual bool | hasEmptyParts () const
| Returns whether a geometry has empty parts/rings. More...
virtual void | removeEmptyParts ()
| Remove empty parts/rings from this geometry. More...
bool | IsRectangle () const
| Returns whether the geometry is a polygon with 4 corners forming a rectangle. More...
OGRPoint * | toPoint ()
| Down-cast to OGRPoint*. More...
const OGRPoint * | toPoint () const
| Down-cast to OGRPoint*. More...
OGRCurve * | toCurve ()
| Down-cast to OGRCurve*. More...
const OGRCurve * | toCurve () const
| Down-cast to OGRCurve*. More...
OGRLineString * | toLineString ()
| Down-cast to OGRLineString*. More...
const OGRLineString * | toLineString () const
| Down-cast to OGRLineString*. More...
OGRLinearRing * | toLinearRing ()
| Down-cast to OGRLinearRing*. More...
const OGRLinearRing * | toLinearRing () const
| Down-cast to OGRLinearRing*. More...
OGRCircularString * | toCircularString ()
| Down-cast to OGRCircularString*. More...
const OGRCircularString * | toCircularString () const
| Down-cast to OGRCircularString*. More...
OGRCompoundCurve * | toCompoundCurve ()
| Down-cast to OGRCompoundCurve*. More...
const OGRCompoundCurve * | toCompoundCurve () const
| Down-cast to OGRCompoundCurve*. More...
OGRSurface * | toSurface ()
| Down-cast to OGRSurface*. More...
const OGRSurface * | toSurface () const
| Down-cast to OGRSurface*. More...
OGRPolygon * | toPolygon ()
| Down-cast to OGRPolygon*. More...
const OGRPolygon * | toPolygon () const
| Down-cast to OGRPolygon*. More...
OGRTriangle * | toTriangle ()
| Down-cast to OGRTriangle*. More...
const OGRTriangle * | toTriangle () const
| Down-cast to OGRTriangle*. More...
OGRCurvePolygon * | toCurvePolygon ()
| Down-cast to OGRCurvePolygon*. More...
const OGRCurvePolygon * | toCurvePolygon () const
| Down-cast to OGRCurvePolygon*. More...
OGRGeometryCollection * | toGeometryCollection ()
| Down-cast to OGRGeometryCollection*. More...
const OGRGeometryCollection * | toGeometryCollection () const
| Down-cast to OGRGeometryCollection*. More...
OGRMultiPoint * | toMultiPoint ()
| Down-cast to OGRMultiPoint*. More...
const OGRMultiPoint * | toMultiPoint () const
| Down-cast to OGRMultiPoint*. More...
OGRMultiLineString * | toMultiLineString ()
| Down-cast to OGRMultiLineString*. More...
const OGRMultiLineString * | toMultiLineString () const
| Down-cast to OGRMultiLineString*. More...
OGRMultiPolygon * | toMultiPolygon ()
| Down-cast to OGRMultiPolygon*. More...
const OGRMultiPolygon * | toMultiPolygon () const
| Down-cast to OGRMultiPolygon*. More...
OGRMultiCurve * | toMultiCurve ()
| Down-cast to OGRMultiCurve*. More...
const OGRMultiCurve * | toMultiCurve () const
| Down-cast to OGRMultiCurve*. More...
OGRMultiSurface * | toMultiSurface ()
| Down-cast to OGRMultiSurface*. More...
const OGRMultiSurface * | toMultiSurface () const
| Down-cast to OGRMultiSurface*. More...
OGRPolyhedralSurface * | toPolyhedralSurface ()
| Down-cast to OGRPolyhedralSurface*. More...
const OGRPolyhedralSurface * | toPolyhedralSurface () const
| Down-cast to OGRPolyhedralSurface*. More...
OGRTriangulatedSurface * | toTriangulatedSurface ()
| Down-cast to OGRTriangulatedSurface*. More...
const OGRTriangulatedSurface * | toTriangulatedSurface () const
| Down-cast to OGRTriangulatedSurface*. More...

## Static Public Member Functions
static OGRLinearRing * | CastToLinearRing (OGRCurve *poCurve)
| Cast to linear ring. More...
static OGRCompoundCurve * | CastToCompoundCurve (OGRCurve *puCurve)
| Cast to compound curve. More...
static OGRLineString * | CastToLineString (OGRCurve *poCurve)
| Cast to linestring. More...
static GEOSContextHandle_t | createGEOSContext ()
| Create a new GEOS context. More...
static void | freeGEOSContext (GEOSContextHandle_t hGEOSCtxt)
| Destroy a GEOS context. More...
static OGRGeometryH | ToHandle (OGRGeometry *poGeom)
| Convert a OGRGeometry* to a OGRGeometryH. More...
static OGRGeometry * | FromHandle (OGRGeometryH hGeom)
| Convert a OGRGeometryH to a OGRGeometry*. More...

## Protected Member Functions
virtual double | get_LinearArea () const
| Compute area of ring / closed linestring. More...
virtual int | ContainsPoint (const OGRPoint *p) const
| Returns if a point is contained in a (closed) curve. More...
virtual int | IntersectsPoint (const OGRPoint *p) const
| Returns if a point intersects a (closed) curve. More...
virtual double | get_AreaOfCurveSegments () const =0
| Get the area of the purely curve portions of a (closed) curve. More...

## Static Protected Member Functions
static OGRLineString * | CastToLineString (OGRLinearRing *poLR)
| Cast to line string. More...
static OGRLinearRing * | CastToLinearRing (OGRLineString *poLS)
| Cast to linear ring. More...

## Detailed Description

Concrete representation of a closed ring.

This class is functionally equivalent to an OGRLineString, but has a separate identity to maintain alignment with the OpenGIS simple feature data model. It exists to serve as a component of an OGRPolygon.

The OGRLinearRing has no corresponding free standing well known binary representation, so importFromWkb() and exportToWkb() will not actually work. There is a non-standard GDAL WKT representation though.

Because OGRLinearRing is not a "proper" free standing simple features object, it cannot be directly used on a feature via SetGeometry(), and cannot generally be used with GEOS for operations like Intersects(). Instead the polygon should be used, or the OGRLinearRing should be converted to an OGRLineString for such operations.

Note: this class exists in SFSQL 1.2, but not in ISO SQL/MM Part 3.

## Constructor & Destructor Documentation

## ◆ OGRLinearRing() [1/2]

OGRLinearRing::OGRLinearRing | ( | const OGRLinearRing & | other | ) |
| default

Copy constructor.

Note: before GDAL 2.1, only the default implementation of the constructor existed, which could be unsafe to use.

Since
  GDAL 2.1

## ◆ OGRLinearRing() [2/2]

OGRLinearRing::OGRLinearRing | ( | const OGRLinearRing * | poSrcRing | ) |
| explicit

Constructor.

Parameters

  poSrcRing | source ring.

## Member Function Documentation

## ◆ accept() [1/2]

virtual void OGRLinearRing::accept | ( | IOGRConstGeometryVisitor * | visitor | ) | const
| inline override virtual

Accept a visitor.

Reimplemented from OGRLineString.

## ◆ accept() [2/2]

virtual void OGRLinearRing::accept | ( | IOGRGeometryVisitor * | visitor | ) |
| inline override virtual

Accept a visitor.

Reimplemented from OGRLineString.

## ◆ addPoint() [1/4]

bool OGRSimpleCurve::addPoint | ( | const OGRPoint * | poPoint | ) |
| inherited

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  poPoint | the point to assign to the new vertex.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ addPoint() [2/4]

bool OGRSimpleCurve::addPoint | ( | double | x,
|  | double | y
| ) |  |
| inherited

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  x | the X coordinate to assign to the new point.
  y | the Y coordinate to assign to the new point.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ addPoint() [3/4]

bool OGRSimpleCurve::addPoint | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inherited

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  x | the X coordinate to assign to the new point.
  y | the Y coordinate to assign to the new point.
  z | the Z coordinate to assign to the new point (defaults to zero).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ addPoint() [4/4]

bool OGRSimpleCurve::addPoint | ( | double | x,
|  | double | y,
|  | double | z,
|  | double | m
| ) |  |
| inherited

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  x | the X coordinate to assign to the new point.
  y | the Y coordinate to assign to the new point.
  z | the Z coordinate to assign to the new point (defaults to zero).
  m | the M coordinate to assign to the new point (defaults to zero).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ addPointM()

bool OGRSimpleCurve::addPointM | ( | double | x,
|  | double | y,
|  | double | m
| ) |  |
| inherited

Add a point to a line string.

The vertex count of the line string is increased by one, and assigned from the passed location value.

There is no SFCOM analog to this method.

Parameters

  x | the X coordinate to assign to the new point.
  y | the Y coordinate to assign to the new point.
  m | the M coordinate to assign to the new point.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ addSubLineString()

void OGRSimpleCurve::addSubLineString | ( | const OGRLineString * | poOtherLine,
|  | int | nStartVertex = `0`,
|  | int | nEndVertex = `-1`
| ) |  |
| inherited

Add a segment of another linestring to this one.

Adds the request range of vertices to the end of this line string in an efficient manner. If the nStartVertex is larger than the nEndVertex then the vertices will be reversed as they are copied.

Parameters

  poOtherLine | the other OGRLineString.
  nStartVertex | the first vertex to copy, defaults to 0 to start with the first vertex in the other linestring.
  nEndVertex | the last vertex to copy, defaults to -1 indicating the last vertex of the other line string.

## ◆ assignSpatialReference()

void OGRGeometry::assignSpatialReference | ( | const OGRSpatialReference * | poSR | ) |
| virtual inherited

Assign spatial reference to this object.

Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it.

Starting with GDAL 2.3, this will also assign the spatial reference to potential sub-geometries of the geometry (OGRGeometryCollection, OGRCurvePolygon/OGRPolygon, OGRCompoundCurve, OGRPolyhedralSurface and their derived classes).

This is similar to the SFCOM IGeometry::put_SpatialReference() method.

This method is the same as the C function OGR_G_AssignSpatialReference().

Parameters

  poSR | new spatial reference system to apply.

Reimplemented in OGRCompoundCurve, OGRCurvePolygon, OGRGeometryCollection, and OGRPolyhedralSurface.

## ◆ begin() [1/2]

OGRSimpleCurve::Iterator OGRSimpleCurve::begin | ( |  | ) |
| inherited

Return begin of point iterator.

Using this iterator for standard range-based loops is safe, but due to implementation limitations, you shouldn't try to access (dereference) more than one iterator step at a time, since you will get a reference to the same OGRPoint& object.

Since
  GDAL 2.3

## ◆ begin() [2/2]

OGRSimpleCurve::ConstIterator OGRSimpleCurve::begin | ( |  | ) | const
| inherited

Return begin of point iterator.

Using this iterator for standard range-based loops is safe, but due to implementation limitations, you shouldn't try to access (dereference) more than one iterator step at a time, since you will get a reference to the same OGRPoint& object.

Since
  GDAL 2.3

## ◆ Boundary()

OGRGeometry * OGRGeometry::Boundary | ( |  | ) | const
| virtual inherited

Compute boundary.

A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_Boundary().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 1.8.0

## ◆ Buffer()

OGRGeometry * OGRGeometry::Buffer | ( | double | dfDist,
|  | int | nQuadSegs = `30`
| ) |  | const
| virtual inherited

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

Some buffer sections are properly described as curves, but are converted to approximate polygons. The nQuadSegs parameter can be used to control how many segments should be used to define a 90 degree curve - a quadrant of a circle. A value of 30 is a reasonable default. Large values result in large numbers of vertices in the resulting buffer geometry while small numbers reduce the accuracy of the result.

This method is the same as the C function OGR_G_Buffer().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  nQuadSegs | the number of segments used to approximate a 90 degree (quadrant) of curvature.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ BufferEx()

OGRGeometry * OGRGeometry::BufferEx | ( | double | dfDist,
|  | CSLConstList | papszOptions
| ) |  | const
| virtual inherited

Compute buffer of geometry.

Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry.

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

The following options are supported. See the GEOS library for more detailed descriptions.

- ENDCAP_STYLE=ROUND/FLAT/SQUARE
- JOIN_STYLE=ROUND/MITRE/BEVEL
- MITRE_LIMIT=double
- QUADRANT_SEGMENTS=double
- SINGLE_SIDED=YES/NO

This function is the same as the C function OGR_G_BufferEx().

Parameters

  dfDist | the buffer distance to be applied. Should be expressed into the same unit as the coordinates of the geometry.
  papszOptions | NULL terminated list of options (may be NULL)

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.10

## ◆ CastToCompoundCurve()

OGRCompoundCurve * OGRCurve::CastToCompoundCurve | ( | OGRCurve * | poCurve | ) |
| static inherited

Cast to compound curve.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poCurve | the input geometry - ownership is passed to the method.

Returns
  new geometry

Since
  GDAL 2.0

## ◆ CastToLinearRing() [1/2]

OGRLinearRing * OGRCurve::CastToLinearRing | ( | OGRCurve * | poCurve | ) |
| static inherited

Cast to linear ring.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poCurve | the input geometry - ownership is passed to the method.

Returns
  new geometry.

Since
  GDAL 2.0

## ◆ CastToLinearRing() [2/2]

OGRLinearRing * OGRLineString::CastToLinearRing | ( | OGRLineString * | poLS | ) |
| static protected inherited

Cast to linear ring.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poLS | the input geometry - ownership is passed to the method.

Returns
  new geometry.

## ◆ CastToLineString() [1/2]

OGRLineString * OGRCurve::CastToLineString | ( | OGRCurve * | poCurve | ) |
| static inherited

Cast to linestring.

The passed in geometry is consumed and a new one returned (or NULL in case of failure)

Parameters

  poCurve | the input geometry - ownership is passed to the method.

Returns
  new geometry.

Since
  GDAL 2.0

## ◆ CastToLineString() [2/2]

OGRLineString * OGRLinearRing::CastToLineString | ( | OGRLinearRing * | poLR | ) |
| static protected

Cast to line string.

The passed in geometry is consumed and a new one returned .

Parameters

  poLR | the input geometry - ownership is passed to the method.

Returns
  new geometry.

## ◆ Centroid()

OGRErr OGRGeometry::Centroid | ( | OGRPoint * | poPoint | ) | const
| virtual inherited

Compute the geometry centroid.

The centroid location is applied to the passed in OGRPoint object. The centroid is not necessarily within the geometry.

This method relates to the SFCOM ISurface::get_Centroid() method however the current implementation based on GEOS can operate on other geometry types such as multipoint, linestring, geometrycollection such as multipolygons. OGC SF SQL 1.1 defines the operation for surfaces (polygons). SQL/MM-Part 3 defines the operation for surfaces and multisurfaces (multipolygons).

This function is the same as the C function OGR_G_Centroid().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  OGRERR_NONE on success or OGRERR_FAILURE on error.

Since
  OGR 1.8.0 as a OGRGeometry method (previously was restricted to OGRPolygon)

## ◆ clone()

OGRLinearRing * OGRLinearRing::clone | ( |  | ) | const
| override virtual

Make a copy of this object.

This method relates to the SFCOM IGeometry::clone() method.

This method is the same as the C function OGR_G_Clone().

Returns
  a new object instance with the same geometry, and spatial reference system as the original.

Reimplemented from OGRLineString.

## ◆ closeRings()

void OGRLinearRing::closeRings | ( |  | ) |
| override virtual

Force rings to be closed.

If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end.

Reimplemented from OGRGeometry.

## ◆ ConcaveHull()

OGRGeometry * OGRGeometry::ConcaveHull | ( | double | dfRatio,
|  | bool | bAllowHoles
| ) |  | const
| virtual inherited

Compute "concave hull" of a geometry.

The concave hull is fully contained within the convex hull and also contains all the points of the input, but in a smaller area. The area ratio is the ratio of the area of the convex hull and the concave hull. Frequently used to convert a multi-point into a polygonal area. that contains all the points in the input Geometry.

A new geometry object is created and returned containing the concave hull of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_ConcaveHull().

This method is built on the GEOS >= 3.11 library If OGR is built without the GEOS >= 3.11 librray, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfRatio | Ratio of the area of the convex hull and the concave hull.
  bAllowHoles | Whether holes are allowed.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.6

## ◆ Contains()

OGRBoolean OGRGeometry::Contains | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for containment.

Tests if actual geometry object contains the passed geometry.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Contains().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if poOtherGeom contains this geometry, otherwise FALSE.

Reimplemented in OGRCurvePolygon.

## ◆ ContainsPoint()

int OGRCurve::ContainsPoint | ( | const OGRPoint * | p | ) | const
| protected virtual inherited

Returns if a point is contained in a (closed) curve.

Final users should use OGRGeometry::Contains() instead.

Parameters

  p | the point to test

Returns
  TRUE if it is inside the curve, FALSE otherwise or -1 if unknown.

Since
  GDAL 2.0

## ◆ ConvexHull()

OGRGeometry * OGRGeometry::ConvexHull | ( |  | ) | const
| virtual inherited

Compute convex hull.

A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked.

This method is the same as the C function OGR_G_ConvexHull().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ CoordinateDimension()

int OGRGeometry::CoordinateDimension | ( |  | ) | const
| inherited

Get the dimension of the coordinates in this object.

This method is the same as the C function OGR_G_CoordinateDimension().

Returns
  this will return 2 for XY, 3 for XYZ and XYM, and 4 for XYZM data.

Since
  GDAL 2.1

## ◆ createGEOSContext()

GEOSContextHandle_t OGRGeometry::createGEOSContext | ( |  | ) |
| static inherited

Create a new GEOS context.

Returns
  a new GEOS context (to be freed with freeGEOSContext())

## ◆ Crosses()

OGRBoolean OGRGeometry::Crosses | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for crossing.

Tests if this geometry and the other passed into the method are crossing.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Crosses().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are crossing, otherwise FALSE.

## ◆ CurveToLine()

OGRLineString * OGRLineString::CurveToLine | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `nullptr`
| ) |  | const
| override virtual inherited

Return a linestring from a curve geometry.

The returned geometry is a new instance whose ownership belongs to the caller.

If the dfMaxAngleStepSizeDegrees is zero, then a default value will be used. This is currently 4 degrees unless the user has overridden the value with the OGR_ARC_STEPSIZE configuration variable.

This method relates to the ISO SQL/MM Part 3 ICurve::CurveToLine() method.

This function is the same as C function OGR_G_CurveToLine().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings or NULL. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a line string approximating the curve

Since
  GDAL 2.0

Implements OGRCurve.

## ◆ DelaunayTriangulation()

OGRGeometry * OGRGeometry::DelaunayTriangulation | ( | double | dfTolerance,
|  | int | bOnlyEdges
| ) |  | const
| virtual inherited

Return a Delaunay triangulation of the vertices of the geometry.

This function is the same as the C function OGR_G_DelaunayTriangulation().

This function is built on the GEOS library, v3.4 or above. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfTolerance | optional snapping tolerance to use for improved robustness
  bOnlyEdges | if TRUE, will return a MULTILINESTRING, otherwise it will return a GEOMETRYCOLLECTION containing triangular POLYGONs.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 2.1

## ◆ Difference()

OGRGeometry * OGRGeometry::Difference | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute difference.

Generates a new geometry which is the region of this geometry with the region of the second geometry removed.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Difference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry removed from "this" geometry.

Returns
  a new geometry to be freed by the caller, or NULL if the difference is empty or if an error occurs.

## ◆ Disjoint()

OGRBoolean OGRGeometry::Disjoint | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for disjointness.

Tests if this geometry and the other passed into the method are disjoint.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Disjoint().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are disjoint, otherwise FALSE.

## ◆ Distance()

double OGRGeometry::Distance | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute distance between two geometries.

Returns the shortest distance between the two geometries. The distance is expressed into the same unit as the coordinates of the geometries.

This method is the same as the C function OGR_G_Distance().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry to compare against.

Returns
  the distance between the geometries or -1 if an error occurs.

## ◆ Distance3D()

double OGRGeometry::Distance3D | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Returns the 3D distance between two geometries.

The distance is expressed into the same unit as the coordinates of the geometries.

This method is built on the SFCGAL library, check it for the definition of the geometry operation. If OGR is built without the SFCGAL library, this method will always return -1.0

This function is the same as the C function OGR_G_Distance3D().

Returns
  distance between the two geometries

Since
  GDAL 2.2

## ◆ dumpReadable() [1/2]

std::string OGRGeometry::dumpReadable | ( | const char * | pszPrefix = `nullptr`,
|  | CSLConstList | papszOptions = `nullptr`
| ) |  | const
| inherited

Dump geometry in well known text format to indicated output file.

A few options can be defined to change the default dump :

- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=WKT or YES (default) : dump the geometry as a WKT
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry
- XY_COORD_PRECISION=integer: number of decimal figures for X,Y coordinates in WKT (added in GDAL 3.9)
- Z_COORD_PRECISION=integer: number of decimal figures for Z coordinates in WKT (added in GDAL 3.9)

Parameters

  pszPrefix | the prefix to put on each line of output.
  papszOptions | NULL terminated list of options (may be NULL)

Returns
  a string with the geometry representation.

Since
  GDAL 3.7

## ◆ dumpReadable() [2/2]

void OGRGeometry::dumpReadable | ( | FILE * | fp,
|  | const char * | pszPrefix = `nullptr`,
|  | CSLConstList | papszOptions = `nullptr`
| ) |  | const
| inherited

Dump geometry in well known text format to indicated output file.

A few options can be defined to change the default dump :

- DISPLAY_GEOMETRY=NO : to hide the dump of the geometry
- DISPLAY_GEOMETRY=WKT or YES (default) : dump the geometry as a WKT
- DISPLAY_GEOMETRY=SUMMARY : to get only a summary of the geometry

This method is the same as the C function OGR_G_DumpReadable().

Parameters

  fp | the text file to write the geometry to.
  pszPrefix | the prefix to put on each line of output.
  papszOptions | NULL terminated list of options (may be NULL)

## ◆ empty()

void OGRSimpleCurve::empty | ( |  | ) |
| override virtual inherited

Clear geometry information.

This restores the geometry to its initial state after construction, and before assignment of actual geometry.

This method relates to the SFCOM IGeometry::Empty() method.

This method is the same as the C function OGR_G_Empty().

Implements OGRGeometry.

## ◆ EndPoint()

void OGRSimpleCurve::EndPoint | ( | OGRPoint * | poPoint | ) | const
| override virtual inherited

Return the curve end point.

This method relates to the SF COM ICurve::get_EndPoint() method.

Parameters

  poPoint | the point to be assigned the end location.

Implements OGRCurve.

## ◆ Equals()

OGRBoolean OGRSimpleCurve::Equals | ( | const OGRGeometry * |  | ) | const
| override virtual inherited

Returns TRUE if two geometries are equivalent.

This operation implements the SQL/MM ST_OrderingEquals() operation.

The comparison is done in a structural way, that is to say that the geometry types must be identical, as well as the number and ordering of sub-geometries and vertices. Or equivalently, two geometries are considered equal by this method if their WKT/WKB representation is equal. Note: this must be distinguished for equality in a spatial way (which is the purpose of the ST_Equals() operation).

This method is the same as the C function OGR_G_Equals().

Returns
  TRUE if equivalent or FALSE otherwise.

Implements OGRGeometry.

## ◆ exportToGEOS()

GEOSGeom OGRGeometry::exportToGEOS | ( | GEOSContextHandle_t | hGEOSCtxt,
|  | bool | bRemoveEmptyParts = `false`
| ) |  | const
| inherited

Returns a GEOSGeom object corresponding to the geometry.

Parameters

  hGEOSCtxt | GEOS context
  bRemoveEmptyParts | Whether empty parts of the geometry should be removed before exporting to GEOS (GDAL >= 3.10)

Returns
  a GEOSGeom object corresponding to the geometry (to be freed with GEOSGeom_destroy_r()), or NULL in case of error

## ◆ exportToGML()

char * OGRGeometry::exportToGML | ( | const char *const * | papszOptions = `nullptr` | ) | const
| virtual inherited

Convert a geometry into GML format.

The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required.

The supported options are :

- FORMAT=GML2/GML3/GML32 (GML2 or GML32 added in GDAL 2.1). If not set, it will default to GML 2.1.2 output.
- GML3_LINESTRING_ELEMENT=curve. (Only valid for FORMAT=GML3) To use gml:Curve element for linestrings. Otherwise gml:LineString will be used .
- GML3_LONGSRS=YES/NO. (Only valid for FORMAT=GML3, deprecated by SRSNAME_FORMAT in GDAL >=2.2). Defaults to YES. If YES, SRS with EPSG authority will be written with the "urn:ogc:def:crs:EPSG::" prefix. In the case the SRS should be treated as lat/long or northing/easting, then the function will take care of coordinate order swapping if the data axis to CRS axis mapping indicates it. If set to NO, SRS with EPSG authority will be written with the "EPSG:" prefix, even if they are in lat/long order.
- SRSNAME_FORMAT=SHORT/OGC_URN/OGC_URL (Only valid for FORMAT=GML3, added in GDAL 2.2). Defaults to OGC_URN. If SHORT, then srsName will be in the form AUTHORITY_NAME:AUTHORITY_CODE. If OGC_URN, then srsName will be in the form urn:ogc:def:crs:AUTHORITY_NAME::AUTHORITY_CODE. If OGC_URL, then srsName will be in the form http://www.opengis.net/def/crs/AUTHORITY_NAME/0/AUTHORITY_CODE. For OGC_URN and OGC_URL, in the case the SRS should be treated as lat/long or northing/easting, then the function will take care of coordinate order swapping if the data axis to CRS axis mapping indicates it.
- GMLID=astring. If specified, a gml:id attribute will be written in the top-level geometry element with the provided value. Required for GML 3.2 compatibility.
- SRSDIMENSION_LOC=POSLIST/GEOMETRY/GEOMETRY,POSLIST. (Only valid for FORMAT=GML3/GML32, GDAL >= 2.0) Default to POSLIST. For 2.5D geometries, define the location where to attach the srsDimension attribute. There are diverging implementations. Some put in on the <gml:posList> element, other on the top geometry element.
- NAMESPACE_DECL=YES/NO. If set to YES, xmlns:gml="http://www.opengis.net/gml" will be added to the root node for GML < 3.2 or xmlns:gml="http://www.opengis.net/gml/3.2" for GML 3.2
- XY_COORD_RESOLUTION=double (added in GDAL 3.9): Resolution for the coordinate precision of the X and Y coordinates. Expressed in the units of the X and Y axis of the SRS. eg 1e-5 for up to 5 decimal digits. 0 for the default behavior.
- Z_COORD_RESOLUTION=double (added in GDAL 3.9): Resolution for the coordinate precision of the Z coordinates. Expressed in the units of the Z axis of the SRS. 0 for the default behavior.

This method is the same as the C function OGR_G_ExportToGMLEx().

Parameters

  papszOptions | NULL-terminated list of options.

Returns
  A GML fragment to be freed with CPLFree() or NULL in case of error.

## ◆ exportToJson()

char * OGRGeometry::exportToJson | ( | CSLConstList | papszOptions = `nullptr` | ) | const
| virtual inherited

Convert a geometry into GeoJSON format.

The returned string should be freed with CPLFree() when no longer required.

The following options are supported :

- XY_COORD_PRECISION=integer: number of decimal figures for X,Y coordinates (added in GDAL 3.9)
- Z_COORD_PRECISION=integer: number of decimal figures for Z coordinates (added in GDAL 3.9)

This method is the same as the C function OGR_G_ExportToJson().

Parameters

  papszOptions | Null terminated list of options, or null (added in 3.9)

Returns
  A GeoJSON fragment to be freed with CPLFree() or NULL in case of error.

## ◆ exportToKML()

char * OGRGeometry::exportToKML | ( |  | ) | const
| virtual inherited

Convert a geometry into KML format.

The returned string should be freed with CPLFree() when no longer required.

This method is the same as the C function OGR_G_ExportToKML().

Returns
  A KML fragment to be freed with CPLFree() or NULL in case of error.

## ◆ exportToWkb()

OGRErr OGRGeometry::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  | const
| inherited

Convert a geometry into well known binary format.

This method relates to the SFCOM IWks::ExportToWKB() method.

This method is the same as the C function OGR_G_ExportToWkb() or OGR_G_ExportToIsoWkb(), depending on the value of eWkbVariant.

Parameters

  eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
  eWkbVariant | What standard to use when exporting geometries with three dimensions (or more). The default wkbVariantOldOgc is the historical OGR variant. wkbVariantIso is the variant defined in ISO SQL/MM and adopted by OGC for SFSQL 1.2.

Returns
  Currently OGRERR_NONE is always returned.

## ◆ exportToWkt() [1/3]

OGRErr OGRGeometry::exportToWkt | ( | char ** | ppszDstText,
|  | OGRwkbVariant | variant = `wkbVariantOldOgc`
| ) |  | const
| inherited

Convert a geometry into well known text format.

This method relates to the SFCOM IWks::ExportToWKT() method.

This method is the same as the C function OGR_G_ExportToWkt().

Parameters

  ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer. After use, *ppszDstText should be freed with CPLFree().
  variant | the specification that must be conformed too : wkbVariantOgc for old-style 99-402 extended dimension (Z) WKB types wkbVariantIso for SFSQL 1.2 and ISO SQL/MM Part 3

Returns
  Currently OGRERR_NONE is always returned.

## ◆ exportToWkt() [2/3]

std::string OGRSimpleCurve::exportToWkt | ( | const OGRWktOptions & | opts = `OGRWktOptions()`,
|  | OGRErr * | err = `nullptr`
| ) |  | const
| override virtual inherited

Export a simple curve to WKT.

Parameters

  opts | Output options.
  err | Pointer to error code, if desired.

Returns
  WKT string representing this simple curve.

Implements OGRGeometry.

Reimplemented in OGRCircularString, and OGRCircularString.

## ◆ exportToWkt() [3/3]

virtual std::string OGRGeometry::exportToWkt | ( | const OGRWktOptions & | opts = `OGRWktOptions()`,
|  | OGRErr * | err = `nullptr`
| ) |  | const
| virtual inherited

Export a WKT geometry.

Parameters

  opts | Output options.
  err | Pointer to error code, if desired.

Returns
  WKT string representing this geometry.

Implements OGRGeometry.

Reimplemented in OGRCircularString.

## ◆ flattenTo2D()

void OGRSimpleCurve::flattenTo2D | ( |  | ) |
| override virtual inherited

Convert geometry to strictly 2D.

In a sense this converts all Z coordinates to 0.0.

This method is the same as the C function OGR_G_FlattenTo2D().

Implements OGRGeometry.

## ◆ freeGEOSContext()

void OGRGeometry::freeGEOSContext | ( | GEOSContextHandle_t | hGEOSCtxt | ) |
| static inherited

Destroy a GEOS context.

Parameters

  hGEOSCtxt | GEOS context

## ◆ FromHandle()

static OGRGeometry * OGRGeometry::FromHandle | ( | OGRGeometryH | hGeom | ) |
| inline static inherited

Convert a OGRGeometryH to a OGRGeometry*.

Since
  GDAL 2.3

## ◆ get_Area()

virtual double OGRLineString::get_Area | ( |  | ) | const
| override virtual inherited

Get the area of the (closed) curve.

This method is designed to be used by OGRCurvePolygon::get_Area().

Returns
  the area of the geometry in square units of the spatial reference system in use.

See also
  get_GeodesicArea() for an alternative method returning areas computed on the ellipsoid, and in square meters.

Since
  GDAL 2.0

Implements OGRCurve.

## ◆ get_AreaOfCurveSegments()

double OGRCurve::get_AreaOfCurveSegments | ( |  | ) | const
| protected pure virtual inherited

Get the area of the purely curve portions of a (closed) curve.

This method is designed to be used on a closed convex curve.

Returns
  the area of the feature in square units of the spatial reference system in use.

Since
  GDAL 2.0

Implemented in OGRCompoundCurve.

## ◆ get_GeodesicArea()

virtual double OGRLineString::get_GeodesicArea | ( | const OGRSpatialReference * | poSRSOverride = `nullptr` | ) | const
| override virtual inherited

Get the area of the (closed) curve, considered as a surface on the underlying ellipsoid of the SRS attached to the geometry.

This method is designed to be used by OGRCurvePolygon::get_GeodesicArea().

The returned area will always be in square meters, and assumes that polygon edges describe geodesic lines on the ellipsoid.

Geodesics follow the shortest route on the surface of the ellipsoid.

If the geometry' SRS is not a geographic one, geometries are reprojected to the underlying geographic SRS of the geometry' SRS. OGRSpatialReference::GetDataAxisToSRSAxisMapping() is honored.

Note that geometries with circular arcs will be linearized in their original coordinate space first, so the resulting geodesic area will be an approximation.

Parameters

  poSRSOverride | If not null, overrides OGRGeometry::getSpatialReference()

Returns
  the area of the geometry in square meters, or a negative value in case of error.

See also
  get_Area() for an alternative method returning areas computed in 2D Cartesian space.

Since
  GDAL 3.9

Implements OGRCurve.

## ◆ get_GeodesicLength()

virtual double OGRLineString::get_GeodesicLength | ( | const OGRSpatialReference * | poSRSOverride = `nullptr` | ) | const
| override virtual inherited

Get the length of the curve, considered as a geodesic line on the underlying ellipsoid of the SRS attached to the geometry.

The returned length will always be in meters.

Geodesics follow the shortest route on the surface of the ellipsoid.

If the geometry' SRS is not a geographic one, geometries are reprojected to the underlying geographic SRS of the geometry' SRS. OGRSpatialReference::GetDataAxisToSRSAxisMapping() is honored.

Note that geometries with circular arcs will be linearized in their original coordinate space first, so the resulting geodesic length will be an approximation.

Parameters

  poSRSOverride | If not null, overrides OGRGeometry::getSpatialReference()

Returns
  the length of the geometry in meters, or a negative value in case of error.

See also
  get_Length() for an alternative method returning areas computed in 2D Cartesian space.

Since
  GDAL 3.10

Implements OGRCurve.

## ◆ get_IsClosed()

int OGRCurve::get_IsClosed | ( |  | ) | const
| virtual inherited

Return TRUE if curve is closed.

Tests if a curve is closed. A curve is closed if its start point is equal to its end point.

For equality tests, the M dimension is ignored.

This method relates to the SFCOM ICurve::get_IsClosed() method.

Returns
  TRUE if closed, else FALSE.

## ◆ get_Length()

double OGRSimpleCurve::get_Length | ( |  | ) | const
| override virtual inherited

Returns the length of the curve.

This method relates to the SFCOM ICurve::get_Length() method.

Returns
  the length of the curve, zero if the curve hasn't been initialized.

See also
  get_GeodesicLength() for an alternative method returning lengths computed on the ellipsoid, and in meters.

Implements OGRCurve.

Reimplemented in OGRCircularString.

## ◆ get_LinearArea()

double OGRSimpleCurve::get_LinearArea | ( |  | ) | const
| protected virtual inherited

Compute area of ring / closed linestring.

The area is computed according to Green's Theorem:

Area is "Sum(x(i)*(y(i+1) - y(i-1)))/2" for i = 0 to pointCount-1, assuming the last point is a duplicate of the first.

Returns
  computed area.

## ◆ getCoordinateDimension()

int OGRGeometry::getCoordinateDimension | ( |  | ) | const
| virtual inherited

Get the dimension of the coordinates in this object.

This method is the same as the C function OGR_G_GetCoordinateDimension().

Deprecated:
  use CoordinateDimension().

Returns
  this will return 2 or 3.

## ◆ getCurveGeometry()

OGRGeometry * OGRLineString::getCurveGeometry | ( | const char *const * | papszOptions = `nullptr` | ) | const
| override virtual inherited

Return curve version of this geometry.

Returns a geometry that has possibly CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by de-approximating curve geometries.

If the geometry has no curve portion, the returned geometry will be a clone of it.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getLinearGeometry().

This function is the same as C function OGR_G_GetCurveGeometry().

Parameters

  papszOptions | options as a null-terminated list of strings. Unused for now. Must be set to NULL.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 2.0

Reimplemented from OGRGeometry.

## ◆ getDimension()

int OGRCurve::getDimension | ( |  | ) | const
| override virtual inherited

Get the dimension of this object.

This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()).

This method is the same as the C function OGR_G_GetDimension().

Returns
  0 for points, 1 for lines and 2 for surfaces.

Implements OGRGeometry.

## ◆ getEnvelope() [1/2]

void OGRSimpleCurve::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const
| override virtual inherited

Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope().

Parameters

  psEnvelope | the structure in which to place the results.

Implements OGRGeometry.

Reimplemented in OGRCircularString.

## ◆ getEnvelope() [2/2]

void OGRSimpleCurve::getEnvelope | ( | OGREnvelope3D * | psEnvelope | ) | const
| override virtual inherited

Computes and returns the bounding envelope (3D) for this geometry in the passed psEnvelope structure.

This method is the same as the C function OGR_G_GetEnvelope3D().

Parameters

  psEnvelope | the structure in which to place the results.

Since
  OGR 1.9.0

Implements OGRGeometry.

Reimplemented in OGRCircularString.

## ◆ getGeometryName()

const char * OGRLinearRing::getGeometryName | ( |  | ) | const
| override virtual

Fetch WKT name for geometry type.

There is no SFCOM analog to this method.

This method is the same as the C function OGR_G_GetGeometryName().

Returns
  name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed.

Reimplemented from OGRLineString.

## ◆ getGeometryType()

OGRwkbGeometryType OGRLineString::getGeometryType | ( |  | ) | const
| override virtual inherited

Fetch geometry type.

Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result.

This method is the same as the C function OGR_G_GetGeometryType().

Returns
  the geometry type code.

Implements OGRGeometry.

## ◆ getIsoGeometryType()

OGRwkbGeometryType OGRGeometry::getIsoGeometryType | ( |  | ) | const
| inherited

Get the geometry type that conforms with ISO SQL/MM Part3.

Returns
  the geometry type that conforms with ISO SQL/MM Part3

## ◆ getLinearGeometry()

OGRGeometry * OGRGeometry::getLinearGeometry | ( | double | dfMaxAngleStepSizeDegrees = `0`,
|  | const char *const * | papszOptions = `nullptr`
| ) |  | const
| virtual inherited

Return, possibly approximate, non-curve version of this geometry.

Returns a geometry that has no CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE in it, by approximating curve geometries.

The ownership of the returned geometry belongs to the caller.

The reverse method is OGRGeometry::getCurveGeometry().

This method is the same as the C function OGR_G_GetLinearGeometry().

Parameters

  dfMaxAngleStepSizeDegrees | the largest step in degrees along the arc, zero to use the default setting.
  papszOptions | options as a null-terminated list of strings. See OGRGeometryFactory::curveToLineString() for valid options.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 2.0

Reimplemented in OGRCircularString, OGRCompoundCurve, OGRCurvePolygon, OGRPolygon, and OGRGeometryCollection.

## ◆ getM()

double OGRSimpleCurve::getM | ( | int | iVertex | ) | const
| inherited

Get measure at vertex.

Returns the M (measure) value at the indicated vertex. If no M value is available, 0.0 is returned.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  M value.

## ◆ getNumPoints()

int OGRSimpleCurve::getNumPoints | ( |  | ) | const
| inline override virtual inherited

Fetch vertex count.

Returns the number of vertices in the line string.

Returns
  vertex count.

Implements OGRCurve.

## ◆ getPoint()

void OGRSimpleCurve::getPoint | ( | int | i,
|  | OGRPoint * | poPoint
| ) |  | const
| inherited

Fetch a point in line string.

This method relates to the SFCOM ILineString::get_Point() method.

Parameters

  i | the vertex to fetch, from 0 to getNumPoints()-1.
  poPoint | a point to initialize with the fetched point.

## ◆ getPointIterator()

OGRPointIterator * OGRSimpleCurve::getPointIterator | ( |  | ) | const
| override virtual inherited

Returns a point iterator over the curve.

The curve must not be modified while an iterator exists on it.

The iterator must be destroyed with OGRPointIterator::destroy().

Returns
  a point iterator over the curve.

Since
  GDAL 2.0

Implements OGRCurve.

## ◆ getPoints() [1/2]

void OGRSimpleCurve::getPoints | ( | OGRRawPoint * | paoPointsOut,
|  | double * | padfZOut = `nullptr`
| ) |  | const
| inherited

Returns all points of line string.

This method copies all points into user list. This list must be at least sizeof(OGRRawPoint) * OGRGeometry::getNumPoints() byte in size. It also copies all Z coordinates.

There is no SFCOM analog to this method.

Parameters

  paoPointsOut | a buffer into which the points is written.
  padfZOut | the Z values that go with the points (optional, may be NULL).

## ◆ getPoints() [2/2]

void OGRSimpleCurve::getPoints | ( | void * | pabyX,
|  | int | nXStride,
|  | void * | pabyY,
|  | int | nYStride,
|  | void * | pabyZ = `nullptr`,
|  | int | nZStride = `0`,
|  | void * | pabyM = `nullptr`,
|  | int | nMStride = `0`
| ) |  | const
| inherited

Returns all points of line string.

This method copies all points into user arrays. The user provides the stride between 2 consecutive elements of the array.

On some CPU architectures, care must be taken so that the arrays are properly aligned.

There is no SFCOM analog to this method.

Parameters

  pabyX | a buffer of at least (nXStride * nPointCount) bytes, may be NULL.
  nXStride | the number of bytes between 2 elements of pabyX.
  pabyY | a buffer of at least (nYStride * nPointCount) bytes, may be NULL.
  nYStride | the number of bytes between 2 elements of pabyY.
  pabyZ | a buffer of at last size (nZStride * nPointCount) bytes, may be NULL.
  nZStride | the number of bytes between 2 elements of pabyZ.
  pabyM | a buffer of at last size (nMStride * nPointCount) bytes, may be NULL.
  nMStride | the number of bytes between 2 elements of pabyM.

Since
  OGR 2.1.0

## ◆ getSpatialReference()

OGRSpatialReference * OGRGeometry::getSpatialReference | ( | void |  | ) | const
| inline inherited

Returns spatial reference system for object.

This method relates to the SFCOM IGeometry::get_SpatialReference() method.

This method is the same as the C function OGR_G_GetSpatialReference().

Returns
  a reference to the spatial reference object. The object may be shared with many geometry objects, and should not be modified.

## ◆ getSubLine()

OGRLineString * OGRSimpleCurve::getSubLine | ( | double | dfDistanceFrom,
|  | double | dfDistanceTo,
|  | int | bAsRatio
| ) |  | const
| virtual inherited

Get the portion of linestring.

The portion of the linestring extracted to new one. The input distances (maybe present as ratio of length of linestring) set begin and end of extracted portion.

Parameters

  dfDistanceFrom | The distance from the origin of linestring, where the subline should begins
  dfDistanceTo | The distance from the origin of linestring, where the subline should ends
  bAsRatio | The flag indicating that distances are the ratio of the linestring length.

Returns
  a newly allocated linestring now owned by the caller, or NULL on failure.

Since
  OGR 1.11.0

## ◆ getX()

double OGRSimpleCurve::getX | ( | int | iVertex | ) | const
| inline inherited

Get X at vertex.

Returns the X value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  X value.

## ◆ getY()

double OGRSimpleCurve::getY | ( | int | iVertex | ) | const
| inline inherited

Get Y at vertex.

Returns the Y value at the indicated vertex. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  X value.

## ◆ getZ()

double OGRSimpleCurve::getZ | ( | int | iVertex | ) | const
| inherited

Get Z at vertex.

Returns the Z (elevation) value at the indicated vertex. If no Z value is available, 0.0 is returned. If iVertex is out of range a crash may occur, no internal range checking is performed.

Parameters

  iVertex | the vertex to return, between 0 and getNumPoints()-1.

Returns
  Z value.

## ◆ hasCurveGeometry()

OGRBoolean OGRGeometry::hasCurveGeometry | ( | int | bLookForNonLinear = `FALSE` | ) | const
| virtual inherited

Returns if this geometry is or has curve geometry.

Returns if a geometry is, contains or may contain a CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, MULTICURVE or MULTISURFACE.

If bLookForNonLinear is set to TRUE, it will be actually looked if the geometry or its subgeometries are or contain a non-linear geometry in them. In which case, if the method returns TRUE, it means that getLinearGeometry() would return an approximate version of the geometry. Otherwise, getLinearGeometry() would do a conversion, but with just converting container type, like COMPOUNDCURVE -> LINESTRING, MULTICURVE -> MULTILINESTRING or MULTISURFACE -> MULTIPOLYGON, resulting in a "loss-less" conversion.

This method is the same as the C function OGR_G_HasCurveGeometry().

Parameters

  bLookForNonLinear | set it to TRUE to check if the geometry is or contains a CIRCULARSTRING.

Returns
  TRUE if this geometry is or has curve geometry.

Since
  GDAL 2.0

Reimplemented in OGRCircularString, OGRCompoundCurve, OGRCurvePolygon, OGRPolygon, OGRGeometryCollection, OGRMultiSurface, OGRMultiPolygon, OGRPolyhedralSurface, OGRMultiPoint, OGRMultiCurve, and OGRMultiLineString.

## ◆ hasEmptyParts()

bool OGRGeometry::hasEmptyParts | ( |  | ) | const
| virtual inherited

Returns whether a geometry has empty parts/rings.

Returns true if removeEmptyParts() will modify the geometry.

This is different from IsEmpty().

Since
  GDAL 3.10

Reimplemented in OGRCompoundCurve, OGRCurvePolygon, OGRGeometryCollection, and OGRPolyhedralSurface.

## ◆ importFromWkb()

OGRErr OGRGeometry::importFromWkb | ( | const GByte * | pabyData,
|  | size_t | nSize = `static_cast<size_t>(-1)`,
|  | OGRwkbVariant | eWkbVariant = `wkbVariantOldOgc`
| ) |  |
| inherited

Assign geometry from well known binary data.

The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKB() method.

This method is the same as the C function OGR_G_ImportFromWkb().

Parameters

  pabyData | the binary input data.
  nSize | the size of pabyData in bytes, or -1 if not known.
  eWkbVariant | if wkbVariantPostGIS1, special interpretation is done for curve geometries code

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

## ◆ importFromWkt() [1/3]

OGRErr OGRGeometry::importFromWkt | ( | char ** | ppszInput | ) |
| inline inherited

Deprecated.

Deprecated:
  in GDAL 2.3

## ◆ importFromWkt() [2/3]

OGRErr OGRSimpleCurve::importFromWkt | ( | const char ** | ppszInput | ) |
| override virtual inherited

deprecated

Implements OGRGeometry.

Reimplemented in OGRCircularString, and OGRCircularString.

## ◆ importFromWkt() [3/3]

OGRErr OGRGeometry::importFromWkt | ( | const char ** | ppszInput | ) |
| virtual inherited

Assign geometry from well known text data.

The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code.

This method relates to the SFCOM IWks::ImportFromWKT() method.

This method is the same as the C function OGR_G_ImportFromWkt().

Parameters

  ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.

Returns
  OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned.

Implements OGRGeometry.

Reimplemented in OGRCircularString.

## ◆ Intersection()

OGRGeometry * OGRGeometry::Intersection | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute intersection.

Generates a new geometry which is the region of intersection of the two geometries operated on. The Intersects() method can be used to test if two geometries intersect.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Intersection().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry intersected with "this" geometry.

Returns
  a new geometry to be freed by the caller, or NULL if there is no intersection or if an error occurs.

## ◆ Intersects()

OGRBoolean OGRGeometry::Intersects | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Do these features intersect?

Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigorous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two geometries overlap.

The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere.

This method is the same as the C function OGR_G_Intersects().

Parameters

  poOtherGeom | the other geometry to test against.

Returns
  TRUE if the geometries intersect, otherwise FALSE.

Reimplemented in OGRPoint, and OGRCurvePolygon.

## ◆ IntersectsPoint()

int OGRCurve::IntersectsPoint | ( | const OGRPoint * | p | ) | const
| protected virtual inherited

Returns if a point intersects a (closed) curve.

Final users should use OGRGeometry::Intersects() instead.

Parameters

  p | the point to test

Returns
  TRUE if it intersects the curve, FALSE otherwise or -1 if unknown.

Since
  GDAL 2.3

## ◆ Is3D()

OGRBoolean OGRGeometry::Is3D | ( |  | ) | const
| inline inherited

Returns whether the geometry has a Z component.

## ◆ isClockwise()

virtual int OGRLineString::isClockwise | ( |  | ) | const
| override virtual inherited

Returns TRUE if the ring has clockwise winding (or less than 2 points)

Assumes that the line is closed.

Returns
  TRUE if clockwise otherwise FALSE.

Reimplemented from OGRCurve.

## ◆ IsConvex()

OGRBoolean OGRCurve::IsConvex | ( |  | ) | const
| virtual inherited

Returns if a (closed) curve forms a convex shape.

Returns
  TRUE if the curve forms a convex shape.

Since
  GDAL 2.0

## ◆ IsEmpty()

OGRBoolean OGRSimpleCurve::IsEmpty | ( |  | ) | const
| override virtual inherited

Returns TRUE (non-zero) if the object has no points.

Normally this returns FALSE except between when an object is instantiated and points have been assigned.

This method relates to the SFCOM IGeometry::IsEmpty() method.

Returns
  TRUE if object is empty, otherwise FALSE.

Implements OGRGeometry.

## ◆ IsMeasured()

OGRBoolean OGRGeometry::IsMeasured | ( |  | ) | const
| inline inherited

Returns whether the geometry has a M component.

## ◆ isPointInRing()

OGRBoolean OGRLinearRing::isPointInRing | ( | const OGRPoint * | poPoint,
|  | int | bTestEnvelope = `TRUE`
| ) |  | const

Returns whether the point is inside the ring.

Parameters

  poPoint | point
  bTestEnvelope | set to TRUE if the presence of the point inside the ring envelope must be checked first.

Returns
  TRUE or FALSE.

## ◆ isPointOnRingBoundary()

OGRBoolean OGRLinearRing::isPointOnRingBoundary | ( | const OGRPoint * | poPoint,
|  | int | bTestEnvelope = `TRUE`
| ) |  | const

Returns whether the point is on the ring boundary.

Parameters

  poPoint | point
  bTestEnvelope | set to TRUE if the presence of the point inside the ring envelope must be checked first.

Returns
  TRUE or FALSE.

## ◆ IsRectangle()

bool OGRGeometry::IsRectangle | ( |  | ) | const
| inherited

Returns whether the geometry is a polygon with 4 corners forming a rectangle.

Since
  GDAL 3.10

## ◆ IsRing()

OGRBoolean OGRGeometry::IsRing | ( |  | ) | const
| virtual inherited

Test if the geometry is a ring.

This method is the same as the C function OGR_G_IsRing().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

## ◆ IsSimple()

OGRBoolean OGRGeometry::IsSimple | ( |  | ) | const
| virtual inherited

Test if the geometry is simple.

This method is the same as the C function OGR_G_IsSimple().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

## ◆ IsValid()

OGRBoolean OGRGeometry::IsValid | ( |  | ) | const
| virtual inherited

Test if the geometry is valid.

This method is the same as the C function OGR_G_IsValid().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return FALSE.

Returns
  TRUE if the geometry has no points, otherwise FALSE.

Reimplemented in OGRCircularString.

## ◆ MakeValid()

OGRGeometry * OGRGeometry::MakeValid | ( | CSLConstList | papszOptions = `nullptr` | ) | const
| virtual inherited

Attempts to make an invalid geometry valid without losing vertices.

Already-valid geometries are cloned without further intervention for default MODE=LINEWORK. Already-valid geometries with MODE=STRUCTURE may be subject to non-significant transformations, such as duplicated point removal, change in ring winding order, etc. (before GDAL 3.10, single-part geometry collections could be returned a single geometry. GDAL 3.10 returns the same type of geometry).

Running OGRGeometryFactory::removeLowerDimensionSubGeoms() as a post-processing step is often desired.

This method is the same as the C function OGR_G_MakeValid().

This function is built on the GEOS >= 3.8 library, check it for the definition of the geometry operation. If OGR is built without the GEOS >= 3.8 library, this function will return a clone of the input geometry if it is valid, or NULL if it is invalid

Parameters

  papszOptions | NULL terminated list of options, or NULL. The following options are available: METHOD=LINEWORK/STRUCTURE. LINEWORK is the default method, which combines all rings into a set of noded lines and then extracts valid polygons from that linework. The STRUCTURE method (requires GEOS >= 3.10 and GDAL >= 3.4) first makes all rings valid, then merges shells and subtracts holes from shells to generate valid result. Assumes that holes and shells are correctly categorized. KEEP_COLLAPSED=YES/NO. Only for METHOD=STRUCTURE. NO (default): collapses are converted to empty geometries YES: collapses are converted to a valid geometry of lower dimension.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.0

## ◆ Normalize()

OGRGeometry * OGRGeometry::Normalize | ( |  | ) | const
| virtual inherited

Attempts to bring geometry into normalized/canonical form.

This method is the same as the C function OGR_G_Normalize().

This function is built on the GEOS library; check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.3

## ◆ operator=()

OGRLinearRing & OGRLinearRing::operator= | ( | const OGRLinearRing & | other | ) |

Assignment operator.

Note: before GDAL 2.1, only the default implementation of the operator existed, which could be unsafe to use.

Since
  GDAL 2.1

## ◆ Overlaps()

OGRBoolean OGRGeometry::Overlaps | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for overlap.

Tests if this geometry and the other passed into the method overlap, that is their intersection has a non-zero area.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Overlaps().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are overlapping, otherwise FALSE.

## ◆ Polygonize()

OGRGeometry * OGRGeometry::Polygonize | ( |  | ) | const
| virtual inherited

Polygonizes a set of sparse edges.

A new geometry object is created and returned containing a collection of reassembled Polygons: NULL will be returned if the input collection doesn't corresponds to a MultiLinestring, or when reassembling Edges into Polygons is impossible due to topological inconsistencies.

This method is the same as the C function OGR_G_Polygonize().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 1.9.0

## ◆ Project()

double OGRSimpleCurve::Project | ( | const OGRPoint * | poPoint | ) | const
| virtual inherited

Project point on linestring.

The input point projected on linestring. This is the shortest distance from point to the linestring. The distance from begin of linestring to the point projection returned.

This method is built on the GEOS library. Check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always return -1, issuing a CPLE_NotSupported error.

Returns
  a distance from the begin of the linestring to the projected point.

## ◆ removeEmptyParts()

void OGRGeometry::removeEmptyParts | ( |  | ) |
| virtual inherited

Remove empty parts/rings from this geometry.

Since
  GDAL 3.10

Reimplemented in OGRCompoundCurve, OGRCurvePolygon, OGRGeometryCollection, and OGRPolyhedralSurface.

## ◆ removePoint()

bool OGRSimpleCurve::removePoint | ( | int | nIndex | ) |
| inherited

Remove a point from a line string.

There is no SFCOM analog to this method.

Parameters

  nIndex | Point index

Since
  GDAL 3.3

## ◆ reversePoints()

void OGRSimpleCurve::reversePoints | ( |  | ) |
| override virtual inherited

Reverse point order.

This method updates the points in this line string in place reversing the point ordering (first for last, etc).

Implements OGRCurve.

## ◆ roundCoordinates()

void OGRGeometry::roundCoordinates | ( | const OGRGeomCoordinatePrecision & | sPrecision | ) |
| inherited

Round coordinates of the geometry to the specified precision.

Note that this is not the same as OGRGeometry::SetPrecision(). The later will return valid geometries, whereas roundCoordinates() does not make such guarantee and may return geometries with invalidities, if they are not compatible of the specified precision. roundCoordinates() supports curve geometries, whereas SetPrecision() does not currently.

One use case for roundCoordinates() is to undo the effect of quantizeCoordinates().

Parameters

  sPrecision | Contains the precision requirements.

Since
  GDAL 3.9

## ◆ roundCoordinatesIEEE754()

void OGRGeometry::roundCoordinatesIEEE754 | ( | const OGRGeomCoordinateBinaryPrecision & | options | ) |
| inherited

Round coordinates of a geometry, exploiting characteristics of the IEEE-754 double-precision binary representation.

Determines the number of bits (N) required to represent a coordinate value with a specified number of digits after the decimal point, and then sets all but the N most significant bits to zero. The resulting coordinate value will still round to the original value (e.g. after roundCoordinates()), but will have improved compressiblity.

Parameters

  options | Contains the precision requirements.

Since
  GDAL 3.9

## ◆ segmentize()

bool OGRSimpleCurve::segmentize | ( | double | dfMaxLength | ) |
| override virtual inherited

Modify the geometry such it has no segment longer then the given distance.

This method modifies the geometry to add intermediate vertices if necessary so that the maximum length between 2 consecutive vertices is lower than dfMaxLength.

Interpolated points will have Z and M values (if needed) set to 0. Distance computation is performed in 2d only

This function is the same as the C function OGR_G_Segmentize()

Parameters

  dfMaxLength | the maximum distance between 2 points after segmentization

Returns
  (since 3.10) true in case of success, false in case of error.

Reimplemented from OGRGeometry.

Reimplemented in OGRCircularString.

## ◆ set3D()

bool OGRSimpleCurve::set3D | ( | OGRBoolean | bIs3D | ) |
| override virtual inherited

Add or remove the Z coordinate dimension.

This method adds or removes the explicit Z coordinate dimension. Removing the Z coordinate dimension of a geometry will remove any existing Z values. Adding the Z dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIs3D | Should the geometry have a Z dimension, either TRUE or FALSE.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

## ◆ setCoordinateDimension()

bool OGRSimpleCurve::setCoordinateDimension | ( | int | nNewDimension | ) |
| override virtual inherited

Set the coordinate dimension.

This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection, a compound curve, a polygon, etc. will affect the children geometries. This will also remove the M dimension if present before this call.

Deprecated:
  use set3D() or setMeasured().

Parameters

  nNewDimension | New coordinate dimension value, either 2 or 3.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

Reimplemented from OGRGeometry.

## ◆ setM()

bool OGRSimpleCurve::setM | ( | int | iPoint,
|  | double | mIn
| ) |  |
| inherited

Set the M of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  mIn | input M coordinate to assign.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setMeasured()

bool OGRSimpleCurve::setMeasured | ( | OGRBoolean | bIsMeasured | ) |
| override virtual inherited

Add or remove the M coordinate dimension.

This method adds or removes the explicit M coordinate dimension. Removing the M coordinate dimension of a geometry will remove any existing M values. Adding the M dimension to a geometry collection, a compound curve, a polygon, etc. will affect the children geometries.

Parameters

  bIsMeasured | Should the geometry have a M dimension, either TRUE or FALSE.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

Since
  GDAL 2.1

Reimplemented from OGRGeometry.

## ◆ setNumPoints()

bool OGRSimpleCurve::setNumPoints | ( | int | nNewPointCount,
|  | int | bZeroizeNewContent = `TRUE`
| ) |  |
| inherited

Set number of points in geometry.

This method primary exists to preset the number of points in a linestring geometry before setPoint() is used to assign them to avoid reallocating the array larger with each call to addPoint().

This method has no SFCOM analog.

Parameters

  nNewPointCount | the new number of points for geometry.
  bZeroizeNewContent | whether to set to zero the new elements of arrays that are extended.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoint() [1/4]

bool OGRSimpleCurve::setPoint | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn
| ) |  |
| inherited

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  xIn | input X coordinate to assign.
  yIn | input Y coordinate to assign.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoint() [2/4]

bool OGRSimpleCurve::setPoint | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn,
|  | double | zIn
| ) |  |
| inherited

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  xIn | input X coordinate to assign.
  yIn | input Y coordinate to assign.
  zIn | input Z coordinate to assign (defaults to zero).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoint() [3/4]

bool OGRSimpleCurve::setPoint | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn,
|  | double | zIn,
|  | double | mIn
| ) |  |
| inherited

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  xIn | input X coordinate to assign.
  yIn | input Y coordinate to assign.
  zIn | input Z coordinate to assign (defaults to zero).
  mIn | input M coordinate to assign (defaults to zero).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoint() [4/4]

bool OGRSimpleCurve::setPoint | ( | int | iPoint,
|  | OGRPoint * | poPoint
| ) |  |
| inherited

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  poPoint | the value to assign to the vertex.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPointM()

bool OGRSimpleCurve::setPointM | ( | int | iPoint,
|  | double | xIn,
|  | double | yIn,
|  | double | mIn
| ) |  |
| inherited

Set the location of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  xIn | input X coordinate to assign.
  yIn | input Y coordinate to assign.
  mIn | input M coordinate to assign (defaults to zero).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoints() [1/4]

bool OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | const double * | padfX,
|  | const double * | padfY,
|  | const double * | padfZIn,
|  | const double * | padfMIn
| ) |  |
| inherited

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in padfX and padfY.
  padfX | list of X coordinates of points being assigned.
  padfY | list of Y coordinates of points being assigned.
  padfZIn | list of Z coordinates of points being assigned.
  padfMIn | list of M coordinates of points being assigned.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoints() [2/4]

bool OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | const double * | padfX,
|  | const double * | padfY,
|  | const double * | padfZIn = `nullptr`
| ) |  |
| inherited

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in padfX and padfY.
  padfX | list of X coordinates of points being assigned.
  padfY | list of Y coordinates of points being assigned.
  padfZIn | list of Z coordinates of points being assigned (defaults to NULL for 2D objects).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoints() [3/4]

bool OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | const OGRRawPoint * | paoPointsIn,
|  | const double * | padfZIn,
|  | const double * | padfMIn
| ) |  |
| inherited

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in paoPointsIn
  paoPointsIn | list of points being assigned.
  padfZIn | the Z values that go with the points.
  padfMIn | the M values that go with the points.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPoints() [4/4]

bool OGRSimpleCurve::setPoints | ( | int | nPointsIn,
|  | const OGRRawPoint * | paoPointsIn,
|  | const double * | padfZIn = `nullptr`
| ) |  |
| inherited

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in paoPointsIn
  paoPointsIn | list of points being assigned.
  padfZIn | the Z values that go with the points (optional, may be NULL).

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPointsM() [1/2]

bool OGRSimpleCurve::setPointsM | ( | int | nPointsIn,
|  | const double * | padfX,
|  | const double * | padfY,
|  | const double * | padfMIn = `nullptr`
| ) |  |
| inherited

Assign all points in a line string.

This method clear any existing points assigned to this line string, and assigns a whole new set.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in padfX and padfY.
  padfX | list of X coordinates of points being assigned.
  padfY | list of Y coordinates of points being assigned.
  padfMIn | list of M coordinates of points being assigned.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ setPointsM() [2/2]

bool OGRSimpleCurve::setPointsM | ( | int | nPointsIn,
|  | const OGRRawPoint * | paoPointsIn,
|  | const double * | padfMIn
| ) |  |
| inherited

Assign all points in a line string.

This method clears any existing points assigned to this line string, and assigns a whole new set. It is the most efficient way of assigning the value of a line string.

There is no SFCOM analog to this method.

Parameters

  nPointsIn | number of points being passed in paoPointsIn
  paoPointsIn | list of points being assigned.
  padfMIn | the M values that go with the points.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ SetPrecision()

OGRGeometry * OGRGeometry::SetPrecision | ( | double | dfGridSize,
|  | int | nFlags
| ) |  | const
| inherited

Set the geometry's precision, rounding all its coordinates to the precision grid, and making sure the geometry is still valid.

This is a stronger version of roundCoordinates().

Note that at time of writing GEOS does no supported curve geometries. So currently if this function is called on such a geometry, OGR will first call getLinearGeometry() on the input and getCurveGeometry() on the output, but that it is unlikely to yield to the expected result.

This function is the same as the C function OGR_G_SetPrecision().

This function is built on the GEOSGeom_setPrecision_r() function of the GEOS library. Check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dfGridSize | size of the precision grid, or 0 for FLOATING precision.
  nFlags | The bitwise OR of zero, one or several of OGR_GEOS_PREC_NO_TOPO and OGR_GEOS_PREC_KEEP_COLLAPSED

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.9

## ◆ setZ()

bool OGRSimpleCurve::setZ | ( | int | iPoint,
|  | double | zIn
| ) |  |
| inherited

Set the Z of a vertex in line string.

If iPoint is larger than the number of necessary the number of existing points in the line string, the point count will be increased to accommodate the request.

There is no SFCOM analog to this method.

Parameters

  iPoint | the index of the vertex to assign (zero based).
  zIn | input Z coordinate to assign.

Returns
  (since 3.10) true in case of success, false in case of memory allocation error

## ◆ Simplify()

OGRGeometry * OGRGeometry::Simplify | ( | double | dTolerance | ) | const
| virtual inherited

Simplify the geometry.

This function is the same as the C function OGR_G_Simplify().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dTolerance | the distance tolerance for the simplification.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 1.8.0

## ◆ SimplifyPreserveTopology()

OGRGeometry * OGRGeometry::SimplifyPreserveTopology | ( | double | dTolerance | ) | const
| inherited

Simplify the geometry while preserving topology.

This function is the same as the C function OGR_G_SimplifyPreserveTopology().

This function is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this function will always fail, issuing a CPLE_NotSupported error.

Parameters

  dTolerance | the distance tolerance for the simplification.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 1.9.0

## ◆ StartPoint()

void OGRSimpleCurve::StartPoint | ( | OGRPoint * | poPoint | ) | const
| override virtual inherited

Return the curve start point.

This method relates to the SF COM ICurve::get_StartPoint() method.

Parameters

  poPoint | the point to be assigned the start location.

Implements OGRCurve.

## ◆ swapXY()

void OGRSimpleCurve::swapXY | ( |  | ) |
| override virtual inherited

Swap x and y coordinates.

Since
  OGR 1.8.0

Reimplemented from OGRGeometry.

## ◆ SymDifference()

OGRGeometry * OGRGeometry::SymDifference | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute symmetric difference.

Generates a new geometry which is the symmetric difference of this geometry and the second geometry passed into the method.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_SymDifference().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry.

Returns
  a new geometry to be freed by the caller, or NULL if the difference is empty or if an error occurs.

Since
  OGR 1.8.0

## ◆ toCircularString() [1/2]

OGRCircularString * OGRGeometry::toCircularString | ( |  | ) |
| inline inherited

Down-cast to OGRCircularString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCircularString.

Since
  GDAL 2.3

## ◆ toCircularString() [2/2]

const OGRCircularString * OGRGeometry::toCircularString | ( |  | ) | const
| inline inherited

Down-cast to OGRCircularString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCircularString.

Since
  GDAL 2.3

## ◆ toCompoundCurve() [1/2]

OGRCompoundCurve * OGRGeometry::toCompoundCurve | ( |  | ) |
| inline inherited

Down-cast to OGRCompoundCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCompoundCurve.

Since
  GDAL 2.3

## ◆ toCompoundCurve() [2/2]

const OGRCompoundCurve * OGRGeometry::toCompoundCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRCompoundCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCompoundCurve.

Since
  GDAL 2.3

## ◆ toCurve() [1/2]

OGRCurve * OGRGeometry::toCurve | ( |  | ) |
| inline inherited

Down-cast to OGRCurve*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbCurve).

Since
  GDAL 2.3

## ◆ toCurve() [2/2]

const OGRCurve * OGRGeometry::toCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRCurve*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbCurve).

Since
  GDAL 2.3

## ◆ toCurvePolygon() [1/2]

OGRCurvePolygon * OGRGeometry::toCurvePolygon | ( |  | ) |
| inline inherited

Down-cast to OGRCurvePolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCurvePolygon or wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toCurvePolygon() [2/2]

const OGRCurvePolygon * OGRGeometry::toCurvePolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRCurvePolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbCurvePolygon or wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toGeometryCollection() [1/2]

OGRGeometryCollection * OGRGeometry::toGeometryCollection | ( |  | ) |
| inline inherited

Down-cast to OGRGeometryCollection*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbGeometryCollection).

Since
  GDAL 2.3

## ◆ toGeometryCollection() [2/2]

const OGRGeometryCollection * OGRGeometry::toGeometryCollection | ( |  | ) | const
| inline inherited

Down-cast to OGRGeometryCollection*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbGeometryCollection).

Since
  GDAL 2.3

## ◆ ToHandle()

static OGRGeometryH OGRGeometry::ToHandle | ( | OGRGeometry * | poGeom | ) |
| inline static inherited

Convert a OGRGeometry* to a OGRGeometryH.

Since
  GDAL 2.3

## ◆ toLinearRing() [1/2]

OGRLinearRing * OGRGeometry::toLinearRing | ( |  | ) |
| inline inherited

Down-cast to OGRLinearRing*.

Implies prior checking that EQUAL(getGeometryName(), "LINEARRING").

Since
  GDAL 2.3

## ◆ toLinearRing() [2/2]

const OGRLinearRing * OGRGeometry::toLinearRing | ( |  | ) | const
| inline inherited

Down-cast to OGRLinearRing*.

Implies prior checking that EQUAL(getGeometryName(), "LINEARRING").

Since
  GDAL 2.3

## ◆ toLineString() [1/2]

OGRLineString * OGRGeometry::toLineString | ( |  | ) |
| inline inherited

Down-cast to OGRLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString.

Since
  GDAL 2.3

## ◆ toLineString() [2/2]

const OGRLineString * OGRGeometry::toLineString | ( |  | ) | const
| inline inherited

Down-cast to OGRLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString.

Since
  GDAL 2.3

## ◆ toMultiCurve() [1/2]

OGRMultiCurve * OGRGeometry::toMultiCurve | ( |  | ) |
| inline inherited

Down-cast to OGRMultiCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiCurve and derived types.

Since
  GDAL 2.3

## ◆ toMultiCurve() [2/2]

const OGRMultiCurve * OGRGeometry::toMultiCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiCurve and derived types.

Since
  GDAL 2.3

## ◆ toMultiLineString() [1/2]

OGRMultiLineString * OGRGeometry::toMultiLineString | ( |  | ) |
| inline inherited

Down-cast to OGRMultiLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiLineString.

Since
  GDAL 2.3

## ◆ toMultiLineString() [2/2]

const OGRMultiLineString * OGRGeometry::toMultiLineString | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiLineString*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiLineString.

Since
  GDAL 2.3

## ◆ toMultiPoint() [1/2]

OGRMultiPoint * OGRGeometry::toMultiPoint | ( |  | ) |
| inline inherited

Down-cast to OGRMultiPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPoint.

Since
  GDAL 2.3

## ◆ toMultiPoint() [2/2]

const OGRMultiPoint * OGRGeometry::toMultiPoint | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPoint.

Since
  GDAL 2.3

## ◆ toMultiPolygon() [1/2]

OGRMultiPolygon * OGRGeometry::toMultiPolygon | ( |  | ) |
| inline inherited

Down-cast to OGRMultiPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPolygon.

Since
  GDAL 2.3

## ◆ toMultiPolygon() [2/2]

const OGRMultiPolygon * OGRGeometry::toMultiPolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiPolygon.

Since
  GDAL 2.3

## ◆ toMultiSurface() [1/2]

OGRMultiSurface * OGRGeometry::toMultiSurface | ( |  | ) |
| inline inherited

Down-cast to OGRMultiSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiSurface and derived types.

Since
  GDAL 2.3

## ◆ toMultiSurface() [2/2]

const OGRMultiSurface * OGRGeometry::toMultiSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRMultiSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbMultiSurface and derived types.

Since
  GDAL 2.3

## ◆ toPoint() [1/2]

OGRPoint * OGRGeometry::toPoint | ( |  | ) |
| inline inherited

Down-cast to OGRPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPoint.

Since
  GDAL 2.3

## ◆ toPoint() [2/2]

const OGRPoint * OGRGeometry::toPoint | ( |  | ) | const
| inline inherited

Down-cast to OGRPoint*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPoint.

Since
  GDAL 2.3

## ◆ toPolygon() [1/2]

OGRPolygon * OGRGeometry::toPolygon | ( |  | ) |
| inline inherited

Down-cast to OGRPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toPolygon() [2/2]

const OGRPolygon * OGRGeometry::toPolygon | ( |  | ) | const
| inline inherited

Down-cast to OGRPolygon*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolygon or wkbTriangle.

Since
  GDAL 2.3

## ◆ toPolyhedralSurface() [1/2]

OGRPolyhedralSurface * OGRGeometry::toPolyhedralSurface | ( |  | ) |
| inline inherited

Down-cast to OGRPolyhedralSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolyhedralSurface or wkbTIN.

Since
  GDAL 2.3

## ◆ toPolyhedralSurface() [2/2]

const OGRPolyhedralSurface * OGRGeometry::toPolyhedralSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRPolyhedralSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbPolyhedralSurface or wkbTIN.

Since
  GDAL 2.3

## ◆ toSimpleCurve() [1/2]

OGRSimpleCurve * OGRCurve::toSimpleCurve | ( |  | ) |
| inline inherited

Down-cast to OGRSimpleCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString or wkbCircularString.

## ◆ toSimpleCurve() [2/2]

const OGRSimpleCurve * OGRCurve::toSimpleCurve | ( |  | ) | const
| inline inherited

Down-cast to OGRSimpleCurve*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbLineString or wkbCircularString.

## ◆ toSurface() [1/2]

OGRSurface * OGRGeometry::toSurface | ( |  | ) |
| inline inherited

Down-cast to OGRSurface*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbSurface).

Since
  GDAL 2.3

## ◆ toSurface() [2/2]

const OGRSurface * OGRGeometry::toSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRSurface*.

Implies prior checking that OGR_GT_IsSubClass(getGeometryType(), wkbSurface).

Since
  GDAL 2.3

## ◆ toTriangle() [1/2]

OGRTriangle * OGRGeometry::toTriangle | ( |  | ) |
| inline inherited

Down-cast to OGRTriangle*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTriangle.

Since
  GDAL 2.3

## ◆ toTriangle() [2/2]

const OGRTriangle * OGRGeometry::toTriangle | ( |  | ) | const
| inline inherited

Down-cast to OGRTriangle*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTriangle.

Since
  GDAL 2.3

## ◆ toTriangulatedSurface() [1/2]

OGRTriangulatedSurface * OGRGeometry::toTriangulatedSurface | ( |  | ) |
| inline inherited

Down-cast to OGRTriangulatedSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTIN.

Since
  GDAL 2.3

## ◆ toTriangulatedSurface() [2/2]

const OGRTriangulatedSurface * OGRGeometry::toTriangulatedSurface | ( |  | ) | const
| inline inherited

Down-cast to OGRTriangulatedSurface*.

Implies prior checking that wkbFlatten(getGeometryType()) == wkbTIN.

Since
  GDAL 2.3

## ◆ Touches()

OGRBoolean OGRGeometry::Touches | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for touching.

Tests if this geometry and the other passed into the method are touching.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Touches().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if they are touching, otherwise FALSE.

## ◆ transform()

OGRErr OGRLinearRing::transform | ( | OGRCoordinateTransformation * | poCT | ) |
| override virtual

Apply arbitrary coordinate transformation to geometry.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry.

This method only does reprojection on a point-by-point basis. It does not include advanced logic to deal with discontinuities at poles or antimeridian. For that, use the OGRGeometryFactory::transformWithOptions() method.

This method is the same as the C function OGR_G_Transform().

Parameters

  poCT | the transformation to apply.

Returns
  OGRERR_NONE on success or an error code.

Reimplemented from OGRSimpleCurve.

## ◆ transformTo()

OGRErr OGRGeometry::transformTo | ( | const OGRSpatialReference * | poSR | ) |
| inherited

Transform geometry to new spatial reference system.

This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units.

This method will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system.

Because this method requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this method to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This method exists primarily for convenience when only transforming a single geometry.

This method is the same as the C function OGR_G_TransformTo().

Parameters

  poSR | spatial reference system to transform to.

Returns
  OGRERR_NONE on success, or an error code.

## ◆ UnaryUnion()

OGRGeometry * OGRGeometry::UnaryUnion | ( |  | ) | const
| inherited

Returns the union of all components of a single geometry.

Usually used to convert a collection into the smallest set of polygons that cover the same area.

See https://postgis.net/docs/ST_UnaryUnion.html for more details.

This method is the same as the C function OGR_G_UnaryUnion().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  GDAL 3.7

## ◆ Union()

OGRGeometry * OGRGeometry::Union | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Compute union.

Generates a new geometry which is the region of union of the two geometries operated on.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Union().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the other geometry unioned with "this" geometry.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

## ◆ UnionCascaded()

OGRGeometry * OGRGeometry::UnionCascaded | ( |  | ) | const
| virtual inherited

Compute union using cascading.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

The input geometry must be a MultiPolygon.

This method is the same as the C function OGR_G_UnionCascaded().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Returns
  a new geometry to be freed by the caller, or NULL if an error occurs.

Since
  OGR 1.8.0

Deprecated:
  Use UnaryUnion() instead

## ◆ Value()

void OGRSimpleCurve::Value | ( | double | dfDistance,
|  | OGRPoint * | poPoint
| ) |  | const
| override virtual inherited

Fetch point at given distance along curve.

This method relates to the SF COM ICurve::get_Value() method.

This function is the same as the C function OGR_G_Value().

Parameters

  dfDistance | distance along the curve at which to sample position. This distance should be between zero and get_Length() for this curve.
  poPoint | the point to be assigned the curve position.

Implements OGRCurve.

Reimplemented in OGRCircularString.

## ◆ Within()

OGRBoolean OGRGeometry::Within | ( | const OGRGeometry * | poOtherGeom | ) | const
| virtual inherited

Test for containment.

Tests if actual geometry object is within the passed geometry.

Geometry validity is not checked. In case you are unsure of the validity of the input geometries, call IsValid() before, otherwise the result might be wrong.

This method is the same as the C function OGR_G_Within().

This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error.

Parameters

  poOtherGeom | the geometry to compare to this geometry.

Returns
  TRUE if poOtherGeom is within this geometry, otherwise FALSE.

Reimplemented in OGRPoint.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrlinearring.cpp